/* 

GPIO test for PicoITX

compilation: add library flag: -lpci


*/


#include <stdio.h>
#include <stdlib.h>




// uint def
#include <stdint.h>





// ioctl
#include <stropts.h>



// open
#include <fcntl.h>

// close
#include <unistd.h>


// via gpio
#include "../driver/via_gpio.h"

/*

connector CN6 on P700-B

GPI4 :
	control register bit: PMIO Rx25[4]=0 & PMIO Rx23[4]=0
	status register: PMIO Rx48[4] 
	Input register:  PMIO Rx48[4] ?
 
GPI5
	control register bit: PMIO Rx24[4]=0 & PMIO Rx22[4]=0
	status register: PMIO Rx48[5]
	Input register:  PMIO Rx48[5] ?

GPIO2
	control register bit: B0D17F0 Rx53[7]=0
	status register : PMIO Rx49[6]
	Output register: PMIO Rx4D[6]
	Input register: PMIO Rx49[6] ?

GPIO3
	control register bit: B0D17F0  Rx53[7]=0
	status register: PMIO Rx49[7]
	Output register: PMIO Rx4D[7]
	Input register: PMIO Rx49[7] ?

*/








int main(int argc, char *argv[])
{



  uint8_t val;

  int fd;

  t_gpio_port gpio_port;

  int i;
  
  char c;
  
 

  if ( (fd = open("/dev/via_gpio",O_RDWR)) == -1)
  {
    fprintf(stderr, "\nERROR: cannot open /dev/via_gpio device! %d\n",fd);
    perror("ERROR: returned");
    
    return -1;
  }
 
 
 
 // ********** GPIO 2 Output
  gpio_port.bit=6;
  gpio_port.address=0x4d;
  ioctl(fd,GPIO_SET,&gpio_port);

  printf("\n GPIO2 output test: wait for any key\n");
   
  scanf("%c",&c);
  
  c=0;
  
  
  gpio_port.bit=6;
  gpio_port.address=0x4d;
  
  for (i=0;i<10;i++)
  
  {
  
    printf("GPIO2 set %d\n",c);  
    
    //val = inb(pmio_base+0x4d);

    
    if (c)
    {
      //val |= 0b01000000; // set to 1
      
      ioctl(fd,GPIO_SET,&gpio_port);
      
      c=0;
    }
    else
    { 
      //val &= ~0b01000000; // set to 0  
      c=1;
      ioctl(fd,GPIO_CLEAR,&gpio_port);
    }
    //outb(val,pmio_base+0x4d);
  
  
  
    usleep(250000);
  
  }
  
 /////////////////////////////////////  
/* GPIO3
	control register bit: B0D17F0  Rx53[7]=0
	status register: PMIO Rx49[7]
	Output register: PMIO Rx4D[7]
	Input register: PMIO Rx49[7] ? */
  
 
  
  gpio_port.bit=7;
  gpio_port.address=0x4d;
  ioctl(fd,GPIO_CLEAR,&gpio_port);
  
  printf("\n GPIO3 output test: wait for any key\n");
   
  scanf("%c",&c);
  
  c=0;
  
  
  gpio_port.bit=7;
  gpio_port.address=0x4d;  

  for (i=0;i<10;i++)
  
  {
  
    printf("GPIO3 set %d\n",c);  
   // val = inb(pmio_base+0x4d);
    
    
    if (c)
    {
      //val |= 0b10000000; // set to 1
      
      ioctl(fd,GPIO_SET,&gpio_port);
      
      c=0;
    }
    else
    { 
      //val &= ~0b10000000; // set to 0  
      c=1;
      ioctl(fd,GPIO_CLEAR,&gpio_port);
    }
    //outb(val,pmio_base+0x4d);
    
    usleep(250000);
  }

// set input to ports
 
 
 /////////////////////////////////////  
 /*  GPIO2
	control register bit: B0D17F0 Rx53[7]=0
	status register : PMIO Rx49[6]
	Output register: PMIO Rx4D[6]
	Input register: PMIO Rx49[6] ? */

 /* // control register
  
  val = pci_read_byte(dev, 0x53);
  
  //printf("GPIO2 1 read 0x%x\n",val);
  
	//val &= ~0b10000000;
	
	val &= ~0b10000000;
  pci_write_byte(dev, 0x53, val);
  
  // set output register 
  
//  val = inb(pmio_base+0x4d);
  
 // val |= 0b01000000; // set to 1

 // val &= ~0b01000000; // set to 0  
  
 // outb(val,pmio_base+0x4d);*/

  gpio_port.bit=6;
  gpio_port.address=0x4d;
  ioctl(fd,GPIO_SET,&gpio_port);
  
/*  val = pci_read_byte(dev, 0x53);
	val &= ~0b00000000;
  pci_write_byte(dev, 0x53, val);*/
 
 
 // read status register
  
  
   printf("\n GPIO2 input test: wait for any key\n");
   
   scanf("%c",&c);
   
   
   gpio_port.bit=6;
   gpio_port.address=0x49;
  
   for (i=0;i<20;i++)
   {
   
     printf("GPIO2 reading value... \n");
     
     //val = inb(pmio_base+0x49);
     //val &= 0b01000000;
    
     ioctl(fd,GPIO_TEST,&gpio_port);
     val =  gpio_port.value;
        
     printf("GPIO2 = %d\n",val==0?0:1);
     usleep(500000);
   
   }
    
  /////////////////////////////////////  
/* GPIO3
	control register bit: B0D17F0  Rx53[7]=0
	status register: PMIO Rx49[7]
	Output register: PMIO Rx4D[7]
	Input register: PMIO Rx49[7] ? */
  
   // control register
  
 /* val = pci_read_byte(dev, 0x53);
	val &= ~0b10000000;
  pci_write_byte(dev, 0x53, val);
  
  // set output register 
  
 // val = inb(pmio_base+0x4d);
  
  //val |= 0b10000000; // set to 1

 // val &= ~0b01000000; // set to 0  
  
  //outb(val,pmio_base+0x4d);*/

  
  gpio_port.bit=7;
  gpio_port.address=0x4d;
  ioctl(fd,GPIO_SET,&gpio_port);
  
  
/*  val = pci_read_byte(dev, 0x53);
	val &= ~0b00000000;
  pci_write_byte(dev, 0x53, val);*/
 
 
 // read status register
  
  
   printf("\n GPIO3 input test: wait for any key\n");
   
   scanf("%c",&c);
   
   gpio_port.bit=7;
   gpio_port.address=0x49;
   for (i=0;i<20;i++)
   {
   
   printf("GPIO3 reading value... \n");
   
  // val = inb(pmio_base+0x49);
   //val &= 0b10000000;
   
   ioctl(fd,GPIO_TEST,&gpio_port);
   val =  gpio_port.value;
   
   printf("GPIO3 = %d\n",val==0?0:1);
   usleep(500000);
   
   }  
 
 
  /////////////////////////////////////    
   /*GPI4 :
	control register bit: PMIO Rx25[4]=0 & PMIO Rx23[4]=0
	status register: PMIO Rx48[4] 
	Input register:  PMIO Rx48[4] ? */
	
    // control registers
   
 /*  val = inb(pmio_base+0x23);
   val &= ~0b00010000;
   outb(val,pmio_base+0x23);
   */
  
  gpio_port.bit=4;
  gpio_port.address=0x23;
  ioctl(fd,GPIO_CLEAR,&gpio_port);
   
   /*val = inb(pmio_base+0x25);
   val &= ~0b00010000;
   outb(val,pmio_base+0x25);
   */
   
  gpio_port.bit=4;
  gpio_port.address=0x25;
  ioctl(fd,GPIO_CLEAR,&gpio_port);
   
   // read status register
  
  
   printf("\n GPI4 input test: wait for any key\n");
   
   scanf("%c",&c);
   
   gpio_port.bit=4;
   gpio_port.address=0x48;
   for (i=0;i<20;i++)
   {
   
     printf("GPI4 reading value... \n");
     
     //val = inb(pmio_base+0x48);
     //val &= 0b00010000;
     
     ioctl(fd,GPIO_TEST,&gpio_port);
     val =  gpio_port.value;
     
     printf("GPI4 = %d\n",val==0?0:1);
     usleep(500000);
   
   }
   
     // 0b00010000;
 
  /////////////////////////////////////   
  /*GPI5
	control register bit: PMIO Rx24[4]=0 & PMIO Rx22[4]=0
	status register: PMIO Rx48[5]
	Input register:  PMIO Rx48[5] ? */
	
	
/*	 val = pci_read_byte(dev, 0x22);
	 val &= ~0b00010000;
   pci_write_byte(dev, 0x22, val);
  
   val = pci_read_byte(dev, 0x24);
   val &= ~0b00010000;
   pci_write_byte(dev, 0x24, val);*/

   // control registers

   /*val = inb(pmio_base+0x22);
   val &= ~0b00010000;
   outb(val,pmio_base+0x22);
   */
   
  gpio_port.bit=4;
  gpio_port.address=0x22;
  ioctl(fd,GPIO_CLEAR,&gpio_port);
   
 /*  val = inb(pmio_base+0x24);
   val &= ~0b00010000;
   outb(val,pmio_base+0x24);
   */
   
  gpio_port.bit=4;
  gpio_port.address=0x24;
  ioctl(fd,GPIO_CLEAR,&gpio_port);

  
   // read status register
   
  
   printf("\n GPI5 input test: wait for any key\n");
   
   scanf("%c",&c);
  
   gpio_port.bit=5;
   gpio_port.address=0x48;
   for (i=0;i<20;i++)
   {
   
     printf("GPI5 reading input value... \n");
     
     //val = inb(pmio_base+0x48);
     //val &= 0b00100000;
     
     ioctl(fd,GPIO_TEST,&gpio_port);
     val =  gpio_port.value;
     
     printf("GPI5 = %d\n",val==0?0:1);
     usleep(500000);
   
   }

  close(fd); 


  return 0;

}
